freeslot("sfx_fhdon1", "sfx_fhdon2")
freeslot(
	"sfx_don50",
	"sfx_don100",
	"sfx_don200",
	"sfx_don300",
	"sfx_don400",
	"sfx_don500",
	"sfx_don600",
	"sfx_don700",
	"sfx_don800",
	"sfx_don900",
	"sfx_donD0K",
	"sfx_donD1K",
	"sfx_donD2K",
	"sfx_donD3K",
	"sfx_donD4K",
	"sfx_donMAX",
	"sfx_kat50",
	"sfx_kat100",
	"sfx_kat200",
	"sfx_kat300",
	"sfx_kat400",
	"sfx_kat500",
	"sfx_kat600",
	"sfx_kat700",
	"sfx_kat800",
	"sfx_kat900",
	"sfx_katD0K",
	"sfx_katD1K",
	"sfx_katD2K",
	"sfx_katD3K",
	"sfx_katD4K",
	"sfx_katMAX"
)

--I have to freeslot all the states in lua

freeslot(
	"S_DON_IDLE",
	"S_DON_FOLLOW",
	"S_DON_HURT",
	"S_DON_LOSE",
	"S_DON_RING",
	"S_DON_HIT",
	"S_KAT_IDLE",
	"S_KAT_FOLLOW",
	"S_KAT_HURT",
	"S_KAT_LOSE",
	"S_KAT_RING",
	"S_KAT_HIT"
)

local donChanStates = {
	[S_DON_IDLE] = 1,
	[S_DON_FOLLOW] = 1,
	[S_DON_HURT] = 1,
	[S_DON_LOSE] = 1,
	[S_DON_RING] = 1,
	[S_DON_HIT] = 1,
	[S_KAT_IDLE] = 2,
	[S_KAT_FOLLOW] = 2,
	[S_KAT_HURT] = 2,
	[S_KAT_LOSE] = 2,
	[S_KAT_RING] = 2,
	[S_KAT_HIT] = 2
}

local function B_CheckIfDonChan(mo)
	return donChanStates[mo.state]
end

local donCombos = {
 [50] = sfx_don50,
 [100] = sfx_don100,
 [200] = sfx_don200,
 [300] = sfx_don300,
 [400] = sfx_don400,
 [500] = sfx_don500,
 [600] = sfx_don600,
 [700] = sfx_don700,
 [800] = sfx_don800,
 [900] = sfx_don900,
 [1000] = sfx_dond0k,
 [1100] = sfx_dond1k,
 [1200] = sfx_dond2k,
 [1300] = sfx_dond3k,
 [1400] = sfx_dond4k
 }
 
 local katCombos = {
 [50] = sfx_kat50,
 [100] = sfx_kat100,
 [200] = sfx_kat200,
 [300] = sfx_kat300,
 [400] = sfx_kat400,
 [500] = sfx_kat500,
 [600] = sfx_kat600,
 [700] = sfx_kat700,
 [800] = sfx_kat800,
 [900] = sfx_kat900,
 [1000] = sfx_katd0k,
 [1100] = sfx_katd1k,
 [1200] = sfx_katd2k,
 [1300] = sfx_katd3k,
 [1400] = sfx_katd4k
 }

local function B_DonAddRing(mo, val)
	if mo.target and mo.target.valid and mo.target.player then
			local p = mo.target.player
			mo.collectedRings = $ + 1
			
			if donCombos[mo.collectedRings] or (mo.collectedRings % 100 == 0 and mo.collectedRings >= 1500) then
				mo.movecount = 24
				local donOrKat = (val==1) and donCombos or katCombos
				S_StartSound(mo, (donOrKat[mo.collectedRings] and donOrKat[mo.collectedRings] or ((val==1) and sfx_donmax or sfx_katmax)))
			end
			
		end
end

addHook("MobjThinker", function(mo)
	if mo and mo.valid and B_CheckIfDonChan(mo) then
	
		mo.lookForFrame = $ or 0
		mo.collectedRings = $ or 0
		
		if mo.movecount > 0 and mo.movecount < 20 then
			mo.spriteyoffset = -sin(FixedAngle((FU*360/30)*(20-mo.movecount+10)))*6
			mo.frame = J
		end
		
		if mo.state == S_DON_FOLLOW or mo.state == S_KAT_FOLLOW then
			if (mo.frame & FF_FRAMEMASK) == (mo.lookForFrame and D or G) then
				S_StartSoundAtVolume(mo, (mo.lookForFrame and sfx_fhdon1 or sfx_fhdon2), 65)
				mo.lookForFrame = abs($-1)
			end
		else
			mo.lookForFrame = 0
		end
		
		if mo.state == S_DON_HURT or mo.state == S_KAT_HURT then
			if not mo.takenCombo then
				mo.collectedRings = 0
			end
			mo.takenCombo = true
		else
			mo.takenCombo = false
		end
	end
end, MT_FOLLOWER)

local function checkDonRing(mo)
	if mo and mo.valid and (not mo.extravalue2) then
		//now check who ated the ring
		
		local pmo = mo.target
		
		if pmo and pmo.valid 
		and pmo.player and pmo.player.valid 
		and pmo.player.follower and pmo.player.follower.valid 
		and B_CheckIfDonChan(pmo.player.follower) then
			B_DonAddRing(pmo.player.follower, B_CheckIfDonChan(pmo.player.follower))
		end
	end
end

addHook("MobjRemoved", checkDonRing, MT_RING)
addHook("MobjRemoved", checkDonRing, MT_FLINGRING)